# NOTE: 8
# Bon travail. Voir les remarques.


from math import*
######################################
# Algorithme 0:                      #
# Exemple de commandes               #
######################################


l1 = ["toto",4,[2,3],3.14]      # declaration de liste
len(l1)                         # longueur de liste
l1[0]                           # element de l1 d'indice 0
l1[1]                           # element de l1 d'indice 1
l1[2]                           # element de l1 d'indice 2: c'est une liste
l1[len(l1)-1]                   # dernier element de l1
l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]
3*[2 ,3 ,4]                     # repetition de liste
l1.append(42)                   # ajout d'un element a la fin de l1
l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1
del(l1[6])                      # suppression de l'element d'indice 6 dans l1
l1.remove('toto')               # suppression des elements "toto" dans l1
l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1
list(range(5))                  # liste contenant les entiers de [[0;4]]]
list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]
list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2
l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]
l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2
l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5
l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4
l1[:]                           # liste contenant tous les elements de l1
l1[::2]                         # liste contenant tous les elements de l1 d'indice pair
l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"
"toto" in l1                    # "toto" est-il dans l1?
3.14 in l1                      # 3.14 est-il dans l1?
l1.index(3.14)                  # recherche du premier indice de l'element 3.14
max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]
sum([1,3,-1])                   # renvoie la somme des Ã©lÃ©ments de la liste [1,3,-1]

######################################
# Algorithme 1:                      #
# Faire une copie de liste           #
######################################

l2=l1[0:8]
l2=l1 #cette instruction est déféctueuse car on ne déclare qui est l1.
#Dans la ligne précédente on déclare bien l1 dans la même ligne en lui assignant des élément

######################################
# Algorithme 2:                      #
# Creation de liste par fonction     #
######################################

l3=[i**2 for i in range(5)]
l4=[i**2 for i in range(1,6,2)]
l16=[1/i for i in range (1, 51)] #On a bien tout les inverses des nombres de 1 à 50, on peut verifier avec print(len(l16)) ##(copiez pour verifier)
l17=[(a,b) for a in range (1,101) for b in range (1,101) if a*b%4 == 0] #(a) est divisible par 4 ou (b) est divisible par 4
l5=[(x,y) for x in range(1,7) for y in range(1,7) if x!=y]
print (l16)
print (l17)



######################################
# Algorithme 3:                      #
# Fonction ProduitScalaire           #
######################################

def Produit_Scalaire(U,V):
    return U[0]*V[0]+U[1]*V[1]

######################################
# Algorithme 4:                      #
# Fonction Norme                     #
######################################

def Norme(I):
    return sqrt(I[0]**2+I[1]**2)


######################################
# Algorithme 5:                      #
# Fonction Determinant               #
######################################

def Determinant(u,v):
    return u[0]*v[1]-u[1]*v[0]

######################################
# Algorithme 6:                      #
# Fonction  SontColineaires          #
######################################

def Sont_Collineaire(u,v):
    if Determinant(u,v) == 0 :
        return True
    else :
        return False


######################################
# Algorithme 7:                      #
# Fonction Pol2Cart                  #
######################################

def Pol2Cart(Pol):
    '''Fonction qui renvoie les coordonnees cartesienne, angle en radian'''
    x = Pol[0]*cos(Pol[1])
    y = Pol[0]*sin(Pol[1])
    return (x,y)

######################################
# Algorithme 8:                      #
# Fonction Cart2Pol                  #
######################################

def Cart2Pol(Cart):
    '''Fonction qui renvoie les coordonnees polaires, angle en radian'''
    rho = sqrt(Cart[0]**2)
    theta = atan(Cart[1]/Cart[0]) # faire une disjonction.
    return (rho,theta)

######################################
# Algorithme 9:                      #
# Fonction EqDroiteOrth              #
######################################

def EqDroiteOrth(A,n):
    # Attention, A est le point, pas le vecteur
    a =A[0]
    b =A[1]
    c = a*n[0] + b*n[1]            
    return (a,b,c)                 #Avec a,b,c il suffit de rajouter des variables x et y pour trouver un critère de colinéarité tel que le critère = 1       



######################################
# Algorithme 10:                     #
# Fonction EqDroiteCol               #
######################################

def EqDroiteCol(A,n):
    # Attention, A est le point, pas le vecteur
    # attention, ce n'est pas la meme equation que precdemment!
    # le critere est different
    a =A[0]
    b =A[1]
    c = a*n[0]*b*n[1]
    return (a,b,c)                 #Avec a,b,c il suffit de rajouter des variables x et y pour trouver un critère de colinéarité tel que le critère = 1

######################################
# Algorithme 11:                     #
# Fonction Barycentre                #
######################################

S1=[[[0,0],1],[[4,4],1]]
S2=[[[0,0],1],[[4,4],1],[[-2,2],2]]
def Barycentre(S1):
    G = ((S1[0]))*(S1[1])/2        #Pas trouvé comment généraliser la fonction pour tout les poids car on ne peut pas accéder a la variable, d'après Thonny : ##Most likely there is nothing wrong with this. I just wanted to remind you that you can't access the global variable like this. If you knew it then please ignore the warning.). (La consigne indiquait bien pour ce système).
    return print(" G =" ,G)  # Qui est thonny?
######################################
# Algorithme 12:                     #
# Algorithme bonus                   #
######################################

print(int(sum(1 for x in range(-100, 101) for y in range(-100, 101) if x**2 + y**2 <= 100**2)))
# TB
##On somme les termes avec i = 1 de x allant de -100 à 100 et pareil pour y (le rayon parcoure le repère de 100 en 100) et on vérifie la condition que les coordonées sont dans le cercle avec le 'if'

