# Créé par UTILISATEUR, le 12/11/2023 en Python 3.7

# Bon travail de recherche
# Note: 9/10
# Voir les remarques plus bas.

######################################
# Algorithme 0:                      #
# Exemple de commandes               #
######################################


l1 = ["toto",4,[2,3],3.14]      # declaration de liste
len(l1)                         # longueur de liste
l1[0]                           # element de l1 d'indice 0
l1[1]                           # element de l1 d'indice 1
l1[2]                           # element de l1 d'indice 2: c'est une liste
l1[len(l1)-1]                   # dernier element de l1
l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]
3*[2 ,3 ,4]                     # repetition de liste
l1.append(42)                   # ajout d'un element a la fin de l1
l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1
del(l1[6])                      # suppression de l'element d'indice 6 dans l1
l1.remove('toto')               # suppression des elements "toto" dans l1
l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1
list(range(5))                  # liste contenant les entiers de [[0;4]]]
list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]
list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2
l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]
l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2
l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5
l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4
l1[:]                           # liste contenant tous les elements de l1
l1[::2]                         # liste contenant tous les elements de l1 d'indice pair
l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"
"toto" in l1                    # "toto" est-il dans l1?
3.14 in l1                      # 3.14 est-il dans l1?
l1.index(3.14)                  # recherche du premier indice de l'element 3.14
max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]
sum([1,3,-1])                   # renvoie la somme des Ã©lÃ©ments de la liste [1,3,-1]

######################################
# Algorithme 1:                      #
# Faire une copie de liste           #
######################################

l2=l1[:]
l2=l1
# Le problème provient de l1=l2 et non de l1=l2[:]: OK

######################################
# Algorithme 2:                      #
# Creation de liste par fonction     #
######################################

l3=[i**2 for i in range(5)]
l4=[i**2 for i in range(1,6,2)]
l5=[(x,y) for x in range(1,7) for y in range(1,7) if x!=y]

l6=[1/i for i in range (1,51)] # ce ne sont pas des inverses de nombres pairs!
l7=[(x,y)for x in range (1,10)for y in range(1,10) if (x*y)%4==0]
######################################
# Algorithme 3:                      #
# Fonction ProduitScalaire           #
######################################

def produitScalaire(A,B):
    return A[0]*B[0]+A[1]*B[1]
######################################
# Algorithme 4:                      #
# Fonction Norme                     #
######################################

from math import sqrt
def Norme (A):
    return sqrt(A[0]**2+A[1]**2)

######################################
# Algorithme 5:                      #
# Fonction Determinant               #
######################################

def Derterminant (A,B):
    return A[0]*B[1]-B[0]*A[1]

######################################
# Algorithme 6:                      #
# Fonction  SontColineaires          #
######################################

def SontColineaire (A,B):
    return A[0]*B[1]==B[0]*A[1]

#####################################
# Algorithme 7:                      #
# Fonction Pol2Cart                  #
######################################

import numpy as np
def pol2cart (rho,theta):
    x=rho*np.cos(theta)
    y=rho*np.sin(theta)
    return [x,y]


######################################
# Algorithme 8:                      #
# Fonction Cart2Pol                  #
######################################

import numpy as np
def cart2pol (x,y):
    rho=no.sqrt(x**2)+(y**2)
    theta=np.arccos(x/rho) # attention, arccos ne convient pas toujours. il faut distinguer plusieurs cas!
    return [rho,theta]

######################################
# Algorithme 9:                      #
# Fonction EqDroiteOrth              #
######################################

def EqDroiteOrth (A,n):
    a = n[0]
    b = n[1]
    c = n[0]*A[0]+n[1]*A[1]
    return [a,b,c]

######################################
# Algorithme 10:                     #
# Fonction EqDroiteCol               #
######################################

def EqDroiteCol (A,d):
    a=d[1]
    b=-d[0]
    c=d[0]*A[0]+d[1]*A[1] # revoir ce calcul.
    return [a,b,c]

######################################
# Algorithme 11:                     #
# Fonction Barycentre                #
######################################

def Barycentre (S):
    X=0
    Y=0
    D=0
    for i in range (len(S)):
        X=X+S[i][1]*S[i][0][0]
        Y=Y+S[i][1]*S[i][0][1]
        D=D+S[i][1]
    G = [X/D,Y/D]
    return G # TB!

S1 = [[[0,0],1],[[4,4],1]]
S2 = [[[0,0],1],[[4,4],1],[[-2,2],2]]

######################################
# Algorithme 12:                     #
# Algorithme bonus                   #
######################################

