# NOTE: 7
# voir les remarques plus bas


# Créé par roger-tg, le 17/11/2023 en Python 3.7
l1 = ["toto",4,[2,3],3.14]      # declaration de liste
len(l1)                         # longueur de liste
l1[0]                           # element de l1 d'indice 0
l1[1]                           # element de l1 d'indice 1
l1[2]                           # element de l1 d'indice 2: c'est une liste
l1[len(l1)-1]                   # dernier element de l1
l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]
3*[2 ,3 ,4]                     # repetition de liste
l1.append(42)                   # ajout d'un element a la fin de l1
l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1
del(l1[6])                      # suppression de l'element d'indice 6 dans l1
l1.remove('toto')               # suppression des elements "toto" dans l1
l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1
list(range(5))                  # liste contenant les entiers de [[0;4]]]
list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]
list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2
l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]
l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2
l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5
l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4
l1[:]                           # liste contenant tous les elements de l1
l1[::2]                         # liste contenant tous les elements de l1 d'indice pair
l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"
"toto" in l1                    # "toto" est-il dans l1?
3.14 in l1                      # 3.14 est-il dans l1?
l1.index(3.14)                  # recherche du premier indice de l'element 3.14
max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]
sum([1,3,-1])                   # renvoie la somme des Ã©lÃ©ments de la liste [1,3,-1]

######################################
# Algorithme 1:                      #
# Faire une copie de liste           #
######################################

l2=l1[:]
l2=l1 #instruction défectueuse

######################################
# Algorithme 2:                      #
# Creation de liste par fonction     #
######################################

l3=[i**2 for i in range(5)]
l4=[i**2 for i in range(1,6,2)]
l5=[(x,y) for x in range(1,7) for y in range(1,7) if x!=y]
l6=[1/i for i in range(2,51,2)]
l7=[(x,y) for x in range(1,101) for y in range(1,101) if (x*y)%4==0]
#(2,2) in l7
#True
#(2,3) in l7
#False



######################################
# Algorithme 3:                      #
# Fonction ProduitScalaire           #
######################################

def ProduitScalaire(U,V):
    return U[0]*V[0]+U[1]*V[1]
#ProduitScalaire([1,1],[1,3])
#4


######################################
# Algorithme 4:                      #
# Fonction Norme                     #
######################################

from math import*                        #Norme([3,4])
#5.0

def Norme(W):
    return sqrt(W[0]**2+W[1]**2)



######################################
# Algorithme 5:                      #
# Fonction Determinant               #
######################################

def determinant(X,Y):
    return X[0]*Y[1]-X[1]*Y[0]



######################################
# Algorithme 6:                      #
# Fonction  SontColineaires          #
######################################
def Sontcolineaires(X,Y):
    X[0]*Y[1]-X[1]*Y[0]==0


######################################
# Algorithme 7:                      #
# Fonction Pol2Cart                  #
######################################
def Pol2Cart(RHO, THETA):
    # attention, la fonction doit prendre une liste en entree et renvoyer une liste
    X = RHO * math.cos(THETA)
    Y = RHO * math.sin(THETA)
    return X, Y


######################################
# Algorithme 8:                      #
# Fonction Cart2Pol                  #
######################################
def Cart2Pol(X, Y):
# attention, la fonction doit prendre une liste en entree et renvoyer une liste
    RHO = math.sqrt(X**2 + Y**2)
    THETA = math.atan2(Y, X) # Faire une disjonction!
    return RHO, THETA


######################################
# Algorithme 9:                      #
# Fonction EqDroiteOrth              #
######################################

def EqDroiteOrth(POINT_A_X, POINT_A_Y, VECTOR_N_A, VECTOR_N_B):
    # attention, la fonction doit prendre deux listes en entree et renvoyer une liste
    A, B = VECTOR_N_A, VECTOR_N_B
    C = A * POINT_A_X + B * POINT_A_Y
    return [A, B, C]

######################################
# Algorithme 10:                     #
# Fonction EqDroiteCol               #
######################################

def EqDroiteCol(POINT_A_X, POINT_A_Y, VECTOR_U_A, VECTOR_U_B):
    # attention, la fonction doit prendre deux listes en entree et renvoyer une liste
    # le critere change ici!
    A, B = VECTOR_U_A, VECTOR_U_B
    C = A * POINT_A_X + B * POINT_A_Y
    return [A, B, C]

######################################
# Algorithme 11:                     #
# Fonction Barycentre                #
######################################

S1 = [[[0,0],1],[[4,4],1]]
S2 = [[[0,0],1],[[4,4],1],[[-2,2],2]]

def Barycentre(systeme_pondere):
    barycentre_X, barycentre_Y = 0, 0
    somme_poids = 0
    for point, poids in systeme_pondere:
        barycentre_X += poids * point[0]
        barycentre_Y += poids * point[1]
        somme_poids += poids
    barycentre_X /= somme_poids
    barycentre_Y /= somme_poids
    return barycentre_X, barycentre_Y

S1 = [[[0, 0], 1], [[4, 4], 1]]
resultat_S1 = Barycentre(S1)
print(resultat_S1)

S2 = [[[0, 0], 1], [[4, 4], 1], [[-2, 2], 2]]
resultat_S2 = Barycentre(S2)
print(resultat_S2)

######################################
# Algorithme 12:                     #
# Algorithme bonus                   #
######################################
